#include "Criatura.h"

Criatura::Criatura(std::string n, Ambiente *a, BITMAP* f, int x, int y) :
        Elemento(n, f, x, y) {
    ambiente = a;
}

void Criatura::rodar() {
    if (getContador() < ambiente->getContador()) {
        setContador(ambiente->getContador());
        executar();
    }
}

void Criatura::executar() {
    if (getNome() == "avatar") {
        executarAvatar();
    } else if (getNome() == "monstro") {
        executarMonstro();
    }
}

void Criatura::executarAvatar() {
    if (key[KEY_UP]) {
        mover(CIMA);
    } else if (key[KEY_DOWN]) {
        mover(BAIXO);
    } else if (key[KEY_LEFT]) {
        mover(ESQUERDA);
    } else if (key[KEY_RIGHT]) {
        mover(DIREITA);
    }
}

void Criatura::executarMonstro() {
    mover((rand() % 4) + 1);
}


bool Criatura::mover(int direcao) {
    bool aux = false;
    setDirecao(direcao);
    if (!aux) {
        switch (direcao) {
        case BAIXO:
            aux = ambiente->moverElemento(this, getX(), getY()+1);
            break;
        case DIREITA:
            aux = ambiente->moverElemento(this, getX()+1, getY());
            break;
        case CIMA:
            aux = ambiente->moverElemento(this, getX(), getY()-1);
            break;
        case ESQUERDA:
            aux = ambiente->moverElemento(this, getX()-1, getY());
            break;
        }
    }
    if (aux) {
        setAndando(true);
    }
    return aux;
}

Criatura::~Criatura() {
}
