#include "Elemento.h"

Elemento::Elemento(std::string n, BITMAP* f, int x, int y) {
    nome = n;
    folha = f;
    posicaoX = x;
    posicaoY = y;
    direcao = BAIXO;
    apagueMe = false;
    andando = false;
    vivo = false;
    contador = 0;

    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 2; j++) {
            std::string aux = "imagens//";
            aux += nome + "." + intToString(i) + "." + intToString(j) + ".bmp";
            imagem[i][j] = load_bitmap(aux.c_str(), NULL);
            if (!imagem[i][j]) {
                imagem[i][j] = imagem[0][0];
            }
        }
    }
}

int Elemento::getX() {
    return posicaoX;
}

int Elemento::getY() {
    return posicaoY;
}
int Elemento::getDirecao() {
    return direcao;
}

void Elemento::setContador(long c) {
    contador = c;
}

long Elemento::getContador() {
    return contador;
}

void Elemento::matar() {
    vivo = false;
}

void Elemento::setDirecao(int dir) {
    direcao = dir;
}

std::string Elemento::getNome() {
    return nome;
}

void Elemento::setAndando(bool a) {
    andando = a;
}

void Elemento::setX(int x) {
    if ((x >= 0) && (x < MAPA_LARGURA)) {
        posicaoX = x;
    }
}

void Elemento::setY(int y) {
    if ((y >=0) && (y < MAPA_ALTURA)) {
        posicaoY = y;
    }
}

bool Elemento::estaVivo() {
    return vivo;
}

bool Elemento::paraApagar() {
    return apagueMe;
}

void Elemento::apagar() {
    apagueMe = true;
}

void Elemento::rodar() {
}

void Elemento::desenhar(int etapa) {
    int aux = etapa;
    if (!andando) aux = 1;
    BITMAP* img = imagem[direcao-1][aux];
    if (img) {
        int auxX = (posicaoX * TAMANHO_CELULA) - img->w + TAMANHO_CELULA;
        int auxY = (posicaoY * TAMANHO_CELULA) - img->h + TAMANHO_CELULA;
        if (andando && (etapa == 0)) {
            int metade = (int) (TAMANHO_CELULA / 2);
            switch (direcao) {
            case BAIXO:
                auxY -= metade;
                break;
            case DIREITA:
                auxX -= metade;
                break;
            case CIMA:
                auxY += metade;
                break;
            case ESQUERDA:
                auxX += metade;
                break;
            }
            andando = false;
        }
        draw_sprite(folha, img, auxX, auxY);
    }
}

Elemento::~Elemento() {
}
